commit 8ac7ead6685b0bdc4c7fa60f0d2788d14627bef2
Author: freddy77 <freddy77>
Date:   Tue Jul 15 15:20:54 2008 +0000

    some code for mssql2005

diff --git a/ChangeLog b/ChangeLog
index 5f7c7b5..f14dda2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Jul 15 17:20:38 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/token.c: some code for mssql2005
+
 Tue Jul 15 17:13:42 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/genparams.c: improved for WCHARs
 
@@ -449,4 +452,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2560 2008/07/15 15:14:12 freddy77 Exp $
+$Id: ChangeLog,v 1.2561 2008/07/15 15:20:54 freddy77 Exp $
diff --git a/src/tds/token.c b/src/tds/token.c
index e4ffcc8..07717c8 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.348 2008/07/09 10:01:04 jklowden Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.349 2008/07/15 15:20:54 freddy77 Exp $");
 
 static int tds_process_msg(TDSSOCKET * tds, int marker);
 static int tds_process_compute_result(TDSSOCKET * tds);
@@ -1437,6 +1437,11 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		break;
 	case 2:
 		curcol->column_size = tds_get_smallint(tds);
+#ifdef ENABLE_DEVELOPING
+		/* under TDS9 this means ?var???(MAX) */
+		if (curcol->column_size < 0 && IS_TDS90(tds))
+			curcol->column_size = 0x1ffffffflu;
+#endif
 		break;
 	case 1:
 		curcol->column_size = tds_get_byte(tds);
@@ -1938,6 +1943,26 @@ tds_process_compute(TDSSOCKET * tds, TDS_INT * pcomputeid)
 	return TDS_SUCCEED;
 }
 
+#ifdef ENABLE_DEVELOPING
+static int
+tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
+{
+	TDS_INT8 len = tds_get_int8(tds);
+	TDS_INT chunk_len;
+
+	/* NULL */
+	if (len == -1) {
+		curcol->column_cur_size = -1;
+		return TDS_SUCCEED;
+	}
+
+	for (;;) {
+		chunk_len = tds_get_int(tds);
+		if (chunk_len < 0)
+			return TDS_SUCCEED;
+	}
+}
+#endif
 
 /**
  * Read a data from wire
@@ -1998,6 +2023,10 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		colsize = tds_get_int(tds);
 		break;
 	case 2:
+#ifdef ENABLE_DEVELOPING
+		if (curcol->column_size == 0x1ffffffflu)
+			return tds9_get_varmax(tds, curcol);
+#endif
 		colsize = tds_get_smallint(tds);
 		break;
 	case 1:

